//---------------------------------------------------------------------------
#ifndef AStDlgH
#define AStDlgH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
//---------------------------------------------------------------------------
class TAutoStatDlg : public TForm
{
__published:	// IDE-managed Components
    TTabControl *TabControl;
    TGroupBox *GroupBox1;
    TTrackBar *TrackBar1;
    TEdit *ENach;
    TEdit *ERazm1;
    TGroupBox *GroupBox2;
    TTrackBar *TrackBar2;
    TEdit *EKon;
    TEdit *ERazm2;
    TButton *Button6;
    TButton *Button5;
    TLabel *Label3;
    TEdit *EKol;
    TEdit *ERazmVr;
    TEdit *EShagVr;
    TLabel *Label4;
    TUpDown *UpDown1;
    void __fastcall TabControlChanging(TObject *Sender,
          bool &AllowChange);
    void __fastcall TabControlChange(TObject *Sender);
    void __fastcall TrackBar1Change(TObject *Sender);
    void __fastcall TrackBar2Change(TObject *Sender);
private:	// User declarations
public:		// User declarations
    __fastcall TAutoStatDlg(TComponent* Owner);
    void SetCaptions();
    void UpdateFields();
    void SaveFields();
    void ReadIniFile();
    void SaveIniFile();
    double m_nach_zn[16];
    double m_kon_zn[16];
    int m_kol[16];
    double m_shag_vrem[16];
};
//---------------------------------------------------------------------------
extern PACKAGE TAutoStatDlg *AutoStatDlg;
//---------------------------------------------------------------------------
#endif
