//---------------------------------------------------------------------------
#ifndef blockH
#define blockH
//---------------------------------------------------------------------------

enum blks {b_none, b_gstep, b_gline, b_gmeandr, b_gpila, b_gimp, b_gsint, b_gcost, b_gsin,
			b_sumblk, b_aperiod, b_graph, b_integr, b_pireg, b_cap, b_acp, b_proporc, b_mulblk, b_ziblk, b_ogrblk};
enum blk_type {t_first, t_dynblk, t_generator, t_proporc, t_sumblk, t_mulblk, t_ziblk, t_ogrblk, t_cap, t_acp, t_graph, t_last};
//---------------------------------------------------------------------------
#include "input1.h"
#include "selcombo.h"
#include "misc.h"

class TBlock : public TCustomControl
{
public:
	__fastcall TBlock(TForm* ParentForm);
    virtual void __fastcall m_Nastr();
	virtual void __fastcall m_SetCursor(int X, int Y);
    virtual void __fastcall SetText() {};
	void __fastcall MouseDown(TMouseButton Button, TShiftState Shift, int X, int Y);
	void __fastcall MouseUp(TMouseButton Button, TShiftState Shift, int X, int Y);
	void __fastcall MouseMove(TShiftState Shift, int X, int Y);
	void __fastcall m_rotate();
	void __fastcall UpdateInOut();
	void __fastcall DrawInOut(TPoint& pnt, bool sel);
	bool drag_fl;
    bool m_sel;
    bool m_rot;
    bool m_have_in;
    bool m_have_out;
	bool m_selIn[16];
	bool m_selOut[16];
    int m_out_per_chan[2];
    int CountOut;
    int CountIn;
	TComponent* m_InpLine[16];
    TPoint origin;
    TPoint m_Outp[16];
    TPoint m_Inp[16];
	AnsiString str[2];
    double m_arg[3];
    AnsiString m_NastrCaption[3];
 	blk_type m_type;
    blks m_blk_type;
    bool m_flag;
    int ch;
	TForm* m_form;
};
//---------------------------------------------------------------------------
class TConnectLine : public TComponent
{
public:
	__fastcall TConnectLine(TComponent* Owner, TBlock* StartBlock, int outCnt);
	__fastcall TConnectLine(TComponent* Owner, TBlock* StartBlock, int outCnt, TBlock* EndBlock, int inCnt);
	__fastcall ~TConnectLine();
	void __fastcall Paint(HDC mDC);
    void __fastcall TConnectLine::Recalc();
    TBlock* m_EndBlock;
    TBlock* m_StartBlock;
    int m_inCnt;
    int m_outCnt;
    TPoint m_StartPt;
    TPoint m_EndPt;
    bool Visible;
};
//---------------------------------------------------------------------------
#endif
