//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "capnastr.h"
#include "asmcode.h"
#include "Main.h"
#include "misc.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TCAPDlg *CAPDlg;
//---------------------------------------------------------------------------
__fastcall TCAPDlg::TCAPDlg(TComponent* Owner)
	: TForm(Owner)
{
	for(int i=0; i<16; i++) m_urov[i] = 0;
}
//---------------------------------------------------------------------------
void __fastcall TCAPDlg::UpdateFields()
{
	EOffset->Text = IntToStr(m_offset[TabControl1->TabIndex]);
	EUrov->Text = FloatToStrF((double)m_urov[TabControl1->TabIndex]/511,ffFixed,10,3);
    EBase->Text = FloatToStrF((double)m_urov[TabControl1->TabIndex]/511*m_base[TabControl1->TabIndex],ffFixed,10,3);
    ERazm1->Text = ((TMainForm*)MainForm)->m_razmern[1][TabControl1->TabIndex];
    ERazm2->Text = ERazm1->Text;
	ERealBase->Text = FloatToStrF(m_real_base[TabControl1->TabIndex],ffFixed,10,3);
	TBOffset->Position = m_offset[TabControl1->TabIndex];
    TBUrov->Position = m_urov[TabControl1->TabIndex]+TBOffset->Position;
	for(short i=0; i<(((TMainForm*)MainForm)->m_col_can_CAP); i++) SendCAP(i, (short)(m_urov[i]+m_offset[i]));
}
//---------------------------------------------------------------------------
void __fastcall TCAPDlg::SaveFields()
{
	m_offset[TabControl1->TabIndex] = (short)TBOffset->Position;
    m_urov[TabControl1->TabIndex] = (short)(TBUrov->Position - TBOffset->Position);
	if(m_urov[TabControl1->TabIndex] != 0)
	    m_base[TabControl1->TabIndex] = myStrToFloat(EBase->Text)*511/(double)m_urov[TabControl1->TabIndex];
	m_real_base[TabControl1->TabIndex] = myStrToFloat(ERealBase->Text);
}
//---------------------------------------------------------------------------
void __fastcall TCAPDlg::TabControl1Changing(TObject *Sender,
      bool &AllowChange)
{
	SaveFields();
}
//---------------------------------------------------------------------------
void __fastcall TCAPDlg::TabControl1Change(TObject *Sender)
{
	UpdateFields();
}
//---------------------------------------------------------------------------
void __fastcall TCAPDlg::FormShow(TObject *Sender)
{
    ((TMainForm*)MainForm)->ResetCAP();
	UpdateFields();
}
//---------------------------------------------------------------------------
void __fastcall TCAPDlg::TBOffsetChange(TObject *Sender)
{
	EOffset->Text = IntToStr(m_offset[TabControl1->TabIndex]);
    TBUrov->Position = m_urov[TabControl1->TabIndex]+TBOffset->Position;
	EUrov->Text = FloatToStrF((double)m_urov[TabControl1->TabIndex]/511,ffFixed,10,3);
	m_offset[TabControl1->TabIndex] = (short)TBOffset->Position;
    m_urov[TabControl1->TabIndex] = (short)(TBUrov->Position - TBOffset->Position);
    EBase->Text = FloatToStrF((double)m_urov[TabControl1->TabIndex]/511*m_base[TabControl1->TabIndex],ffFixed,10,3);
	for(short i=0; i<(((TMainForm*)MainForm)->m_col_can_CAP); i++) SendCAP(i,(short)(m_urov[i]+m_offset[i]));
}
//---------------------------------------------------------------------------
void __fastcall TCAPDlg::TBUrovChange(TObject *Sender)
{
	EUrov->Text = FloatToStrF((double)m_urov[TabControl1->TabIndex]/511,ffFixed,10,3);
    m_urov[TabControl1->TabIndex] = (short)(TBUrov->Position - TBOffset->Position);
    EBase->Text = FloatToStrF((double)m_urov[TabControl1->TabIndex]/511*m_base[TabControl1->TabIndex],ffFixed,10,3);
	for(short i=0; i<(((TMainForm*)MainForm)->m_col_can_CAP); i++) SendCAP(i,(short)(m_urov[i]+m_offset[i]));
}
//---------------------------------------------------------------------------

