//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "dselcord.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TSelCoord *SelCoord;
//---------------------------------------------------------------------------
__fastcall TSelCoord::TSelCoord(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void TSelCoord::SetCaptions(AnsiString labels[2][16], short coords_mask, short coords_to_filter)
{
	int i;
	for(i=0; i<(GroupBox1->ControlCount); i++)
    {
		((TCheckBox*)GroupBox1->Controls[i])->Caption = labels[0][i];
     	((TCheckBox*)GroupBox1->Controls[i])->Enabled = (coords_mask >> i)& 1;
     	((TCheckBox*)GroupBox1->Controls[i])->Checked = (coords_to_filter >> i)& 1;
    }
}
//---------------------------------------------------------------------------
short TSelCoord::GetCoordsToFilter()
{
	int i;
	short coords_mask = 0;
	for(i=0; i<(GroupBox1->ControlCount); i++)
    {
     	if(((TCheckBox*)GroupBox1->Controls[i])->Checked) coords_mask |= (short)(1<<i);
        else coords_mask &= (short)~(1<<i);
    }
    return coords_mask;
}
//---------------------------------------------------------------------------
