//----------------------------------------------------------------------------
#ifndef graphuntH
#define graphuntH
//----------------------------------------------------------------------------
#include <vcl\Controls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Graphics.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Windows.hpp>
#include <vcl\System.hpp>
#include <StdCtrls.hpp>

#include "graphtpl.h"
#include <ActnList.hpp>
#include <Menus.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
//----------------------------------------------------------------------------
class TGraphFrm : public TForm
{
__published:
	TActionList *ActionList1;
	TPopupMenu *PMGraph;
	TAction *AGrNast;
	TMenuItem *N1;
	TAction *ASave;
	TMainMenu *MainMenu1;
	TAction *ASaveAs;
	TMenuItem *N2;
	TMenuItem *N3;
	TMenuItem *N4;
	TMenuItem *N5;
	TMenuItem *N6;
	TMenuItem *N7;
	TMenuItem *N8;
	TMenuItem *N9;
	TMenuItem *N10;
	TMenuItem *N11;
	TMenuItem *N12;
	TMenuItem *N13;
	TSaveDialog *SaveDialog1;
	TAction *ATable;
	TMenuItem *N14;
	TAction *AHanning;
	TAction *ASrKwad;
	TAction *AVipr;
	TAction *AExpSmooth;
	TMenuItem *N15;
	TMenuItem *N16;
	TMenuItem *N17;
	TMenuItem *N18;
	TMenuItem *N19;
	TAction *ASort;
	TMenuItem *N20;
	TAction *APrint;
	TMenuItem *N21;
	TMenuItem *N22;
	TMenuItem *N23;
	TMenuItem *N24;
	TMenuItem *N25;
	TPanel *Panel1;
	TSplitter *Splitter_legend;
	TPanel *LegendPanel;
	TSplitter *Splitter_caption;
	TPanel *CaptionPanel;
	TSplitter *Splitter_base;
	TPanel *BasePanel;
	TPanel *GraphPanel;
	TPaintBox *GraphPaintBox;
	TPaintBox *LegendPaintBox;
	TPopupMenu *PMBase;
	TMenuItem *SelFontBase;
	TFontDialog *FontDialog;
	TPopupMenu *PMCaption;
	TMenuItem *SelFontCaption;
	TAction *ACopy;
	TMenuItem *N27;
	TAction *AShowFiltered;
	TAction *ASaveFiltered;
	TMenuItem *N28;
	TMenuItem *N29;
	TMenuItem *N30;
	TMenuItem *N31;
	TMenuItem *N32;
	TMenuItem *N33;
	TMenuItem *N34;
	TMenuItem *N35;
	TMenuItem *N36;
	TMenuItem *N37;
	TMenuItem *N38;
	TMenuItem *N39;
	TMemo *MBase;
	TMemo *MCaption;
	TMenuItem *N26;
	TMenuItem *N40;
	TMenuItem *N41;
	TMenuItem *N51;
	TMenuItem *N52;
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall FormPaint(TObject *Sender);
	void __fastcall FormResize(TObject *Sender);
	void __fastcall AGrNastExecute(TObject *Sender);
	void __fastcall ASaveExecute(TObject *Sender);
	void __fastcall ASaveAsExecute(TObject *Sender);
	void __fastcall ATableExecute(TObject *Sender);
	void __fastcall AHanningExecute(TObject *Sender);
	void __fastcall ASrKwadExecute(TObject *Sender);
	void __fastcall AViprExecute(TObject *Sender);
	void __fastcall AExpSmoothExecute(TObject *Sender);
	void __fastcall ASortExecute(TObject *Sender);
	void __fastcall APrintExecute(TObject *Sender);
	void __fastcall GraphPaintBoxPaint(TObject *Sender);
	void __fastcall LegendPaintBoxPaint(TObject *Sender);
	void __fastcall GraphPaintBoxMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
	void __fastcall GraphPaintBoxMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
	void __fastcall GraphPaintBoxMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall SelFontBaseClick(TObject *Sender);
	void __fastcall SelFontCaptionClick(TObject *Sender);
	void __fastcall ACopyExecute(TObject *Sender);
	void __fastcall AShowFilteredExecute(TObject *Sender);
	void __fastcall AShowFilteredUpdate(TObject *Sender);
	void __fastcall ASaveFilteredExecute(TObject *Sender);
	void __fastcall ASaveFilteredUpdate(TObject *Sender);
	void __fastcall NonStaticFilterUpdate(TObject *Sender);
	void __fastcall StaticFilterUpdate(TObject *Sender);
private:
public:
	virtual __fastcall TGraphFrm(TComponent *Owner);
	virtual __fastcall ~TGraphFrm();
    void __fastcall LoadFromFile(AnsiString FileName);
    void __fastcall SaveToFile(AnsiString FileName);
    void __fastcall UpdateAll();
	TShortGraph m_graph;
    AnsiString m_FileName;
    TRect mg;
};
//----------------------------------------------------------------------------
#include "block.h"
//---------------------------------------------------------------------------

class TGraphBlk : public TBlock
{
__published:
	void __fastcall DblClick();
	void __fastcall MouseDown(TMouseButton Button, TShiftState Shift, int X, int Y);
	void __fastcall MouseUp(TMouseButton Button, TShiftState Shift, int X, int Y);
	void __fastcall MouseMove(TShiftState Shift, int X, int Y);
	void __fastcall m_Print();
public:
	__fastcall TGraphBlk(TForm* ParentForm);
	__fastcall ~TGraphBlk();
	void __fastcall Paint();
	void __fastcall m_SetCursor(int X, int Y);
    void __fastcall m_Nastr();
	TDoubleGraph m_graph;
    TRect m_place;
    TPoint m_XY;
    bool m_resize;
};
//---------------------------------------------------------------------------
#endif
