//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "perehdlg.h"
#include "asmcode.h"
#include "Main.h"
#include "misc.h"
#include <stdio.h>
#include <IniFiles.hpp>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TPerDlg *PerDlg;
//---------------------------------------------------------------------------
__fastcall TPerDlg::TPerDlg(TComponent* Owner)
	: TForm(Owner)
{
	m_file = _tempnam("","Prv");
}
//---------------------------------------------------------------------------
void __fastcall TPerDlg::TabControl1Change(TObject *Sender)
{
 	UpdateFieldsCAP();
}
//---------------------------------------------------------------------------
void __fastcall TPerDlg::UpdateFieldsCAP()
{
	TrackBar1->Min = -((TMainForm*)MainForm)->m_offset[1][TabControl1->TabIndex];
	TrackBar1->Max = 1022 + TrackBar1->Min;
    TrackBar1->Position = m_valCAP[TabControl1->TabIndex];
	CheckBox17->Checked = (m_coords_mask[1] >> (TabControl1->TabIndex))& 1;
	Edit2->Text = FloatToStrF(m_timeCAP[TabControl1->TabIndex],ffFixed,10,3);
    Edit3->Text = FloatToStrF(m_valCAP[TabControl1->TabIndex]/511
    *((TMainForm*)MainForm)->m_base[1][TabControl1->TabIndex],ffFixed,10,3);
    Edit4->Text = FloatToStrF(m_timeZI[TabControl1->TabIndex],ffFixed,10,3);
    ERazm->Text = ((TMainForm*)MainForm)->m_razmern[1][TabControl1->TabIndex];
    SetAuto(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TPerDlg::SaveFieldsCAP()
{
    if(CheckBox17->Checked) m_coords_mask[1] |= (short)(1<<(TabControl1->TabIndex));
    else m_coords_mask[1] &= (short)~(1<<(TabControl1->TabIndex));
	m_timeCAP[TabControl1->TabIndex] = myStrToFloat(Edit2->Text);
    m_valCAP[TabControl1->TabIndex] = (double)TrackBar1->Position;
	m_timeZI[TabControl1->TabIndex] = myStrToFloat(Edit4->Text);
}
//---------------------------------------------------------------------------
void __fastcall TPerDlg::UpdateFieldsACP()
{
	int i;
	for(i=0; i<(GroupBox1->ControlCount); i++)
     	((TCheckBox*)GroupBox1->Controls[i])->Checked = (m_coords_mask[0] >> i)& 1;
    Edit1->Text = FloatToStrF(m_req_time, ffFixed,10,3);
}
//---------------------------------------------------------------------------
void __fastcall TPerDlg::SaveFieldsACP()
{
	int i;
	for(i=0; i<(GroupBox1->ControlCount); i++)
    {
     	if(((TCheckBox*)GroupBox1->Controls[i])->Checked) m_coords_mask[0] |= (short)(1<<i);
        else m_coords_mask[0] &= (short)~(1<<i);
    }
    m_req_time = myStrToFloat(Edit1->Text);
}
//---------------------------------------------------------------------------
void __fastcall TPerDlg::SetCaptions()
{
	int i;
	for(i=0; i<(GroupBox1->ControlCount); i++)
		((TCheckBox*)GroupBox1->Controls[i])->Caption = ((TMainForm*)MainForm)->m_labels[0][i];
    TabControl1->Tabs->Clear();
    for(i=0; i<(((TMainForm*)MainForm)->m_col_can_CAP); i++) TabControl1->Tabs->Add(((TMainForm*)MainForm)->m_labels[1][i]);
}
//---------------------------------------------------------------------------
void __fastcall TPerDlg::TabControl1Changing(TObject *Sender,
      bool &AllowChange)
{
	SaveFieldsCAP();
}
//---------------------------------------------------------------------------
void __fastcall TPerDlg::FormShow(TObject *Sender)
{
	((TMainForm*)MainForm)->ResetCAP();
	UpdateFieldsCAP();
    UpdateFieldsACP();
    SetCaptions();
}
//---------------------------------------------------------------------------
void __fastcall TPerDlg::TrackBar1Change(TObject *Sender)
{
	Edit3->Text = FloatToStrF((double)TrackBar1->Position/511
    *((TMainForm*)MainForm)->m_base[1][TabControl1->TabIndex],ffFixed,10,3);
}
//---------------------------------------------------------------------------
void __fastcall TPerDlg::Button1Click(TObject *Sender)
{
	TrackBar1->Position = 0;
}
//---------------------------------------------------------------------------
void __fastcall TPerDlg::StartScanThread()
{
	int i;
	if(Button3->Caption == "")
    {
        if(m_thr) m_thr->beg_clock += GetTickCount() - stop_clock;
        else
        {
			SaveFieldsCAP();
    		SaveFieldsACP();
         	m_thr = new TScanThr(true);
            m_thr->dlg = this;
			m_thr->m_req_time = m_req_time;
            for(i=0; i<16; i++)
            {
            	m_thr->m_val_CAP[i] = m_valCAP[i];
            	m_thr->m_nagr_time[i] = m_timeCAP[i];
                m_thr->m_zi_time[i] = m_timeZI[i];
                m_thr->m_offs_CAP[i] = ((TMainForm*)MainForm)->m_offset[1][i];
                m_thr->m_offs_ACP[i] = ((TMainForm*)MainForm)->m_offset[0][i];
            }
			m_thr->m_file = m_file;
            m_thr->m_coords_mask[0] = m_coords_mask[0];
            if(ChBAuto->Checked) m_thr->m_coords_mask[1] = m_coords_mask[1];
			else m_thr->m_coords_mask[1] = 0;
            m_thr->m_auto = ChBAuto->Checked;
        }
     	Button3->Caption = "";
        m_thr->Resume();
    }
    else
    {
        m_thr->Suspend();
        stop_clock = GetTickCount();
    	Button3->Caption = "";
    }
}
//---------------------------------------------------------------------------
void __fastcall TPerDlg::Button3Click(TObject *Sender)
{
	StartScanThread();
}
//---------------------------------------------------------------------------
void __fastcall TPerDlg::SetAuto(TObject *Sender)
{
    GroupBox3->Enabled = ChBAuto->Checked;
    CheckBox17->Enabled = ChBAuto->Checked;
    Edit2->Enabled = ChBAuto->Checked && CheckBox17->Checked;
    Edit3->Enabled = ChBAuto->Checked && CheckBox17->Checked;
    Edit4->Enabled = ChBAuto->Checked && CheckBox17->Checked;
    ERazm->Enabled = ChBAuto->Checked && CheckBox17->Checked;
    Button1->Enabled = ChBAuto->Checked && CheckBox17->Checked;
    Button2->Enabled = ChBAuto->Checked && CheckBox17->Checked;
    TrackBar1->Enabled = ChBAuto->Checked && CheckBox17->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TPerDlg::ReadIniFile()
{
    int i;
	TIniFile* RegFile = new TIniFile(((TMainForm*)MainForm)->m_ini_name);
	m_req_time = RegFile->ReadFloat("  (defaults)","  ",1);
	for(i=0; i<(((TMainForm*)MainForm)->m_col_can_CAP); i++)
    {
    	m_valCAP[i] = RegFile->ReadFloat("  (defaults)","   "+IntToStr(i+1),0);
    	m_timeCAP[i] = RegFile->ReadFloat("  (defaults)","   "+IntToStr(i+1),0);
    	m_timeZI[i] = RegFile->ReadFloat("  (defaults)","    "+IntToStr(i+1),0);
    }
	m_coords_mask[0] = (short)RegFile->ReadInteger("  (defaults)","  ",0);
	m_coords_mask[1] = (short)RegFile->ReadInteger("  (defaults)","  ",0);
	ChBAuto->Checked = RegFile->ReadBool("  (defaults)"," ",false);
    ChBStartFromStend->Checked = RegFile->ReadBool("  (defaults)","  ",true);
    delete RegFile;
}
//---------------------------------------------------------------------------
void __fastcall TPerDlg::SaveIniFile()
{
    int i;
	SaveFieldsCAP();
    SaveFieldsACP();
	TIniFile* RegFile = new TIniFile(((TMainForm*)MainForm)->m_ini_name);
	RegFile->WriteFloat("  (defaults)","  ",m_req_time);
	for(i=0; i<(((TMainForm*)MainForm)->m_col_can_CAP); i++)
    {
    	RegFile->WriteFloat("  (defaults)","   "+IntToStr(i+1),m_valCAP[i]);
    	RegFile->WriteFloat("  (defaults)","   "+IntToStr(i+1),m_timeCAP[i]);
    	RegFile->WriteFloat("  (defaults)","    "+IntToStr(i+1),m_timeZI[i]);
    }
	RegFile->WriteInteger("  (defaults)","  ",m_coords_mask[0]);
	RegFile->WriteInteger("  (defaults)","  ",m_coords_mask[1]);
	RegFile->WriteBool("  (defaults)"," ",ChBAuto->Checked);
    RegFile->WriteBool("  (defaults)","  ",ChBStartFromStend->Checked);
    delete RegFile;
}
//---------------------------------------------------------------------------

void __fastcall TPerDlg::AOKExecute(TObject *Sender)
{
	if(m_thr)
    {
    	m_thr->Terminate();
        m_thr->Resume();
    }
    else
    {
    	StartScanThread();
        Button3->Enabled = false;
    }
    m_thr->WaitFor();
//	ShowMessage(" "+IntToStr(m_thr->col_points)+" ");
    ModalResult = mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TPerDlg::ACancelExecute(TObject *Sender)
{
	if(m_thr)
    {
    	m_thr->Terminate();
        m_thr->Resume();
	    m_thr->WaitFor();
    }
	if(FileExists(m_file)) DeleteFile(m_file);
	ModalResult = mrCancel;
}
//---------------------------------------------------------------------------
void __fastcall TPerDlg::FormClose(TObject *Sender, TCloseAction &Action)
{
	((TMainForm*)MainForm)->ResetCAP();
}
//---------------------------------------------------------------------------

void __fastcall TPerDlg::Button2MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	SendCAP((short)TabControl1->TabIndex, m_valCAP[TabControl1->TabIndex]);
}
//---------------------------------------------------------------------------

void __fastcall TPerDlg::Button2MouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	((TMainForm*)MainForm)->ResetCAP();
}
//---------------------------------------------------------------------------

void __fastcall TPerDlg::TimerBgTimer(TObject *Sender)
{
	if(ChBStartFromStend->Checked && CheckStartBtn())
    {
		if(m_thr)
    	{
    		m_thr->Terminate();
	        m_thr->Resume();
    	}
	    else
    	{
    		StartScanThread();
	        Button3->Enabled = false;
    	}
	    m_thr->WaitFor();
		ShowMessage(" "+IntToStr(m_thr->col_points)+" ");
	    ModalResult = mrOk;
    }
}
//---------------------------------------------------------------------------


