//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "rk_funcs.h"

#pragma package(smart_init)
//---------------------------------------------------------------------------
#include<math.h>
#define PI2 6.28318530717958
//#define MAX_NUM_PER 15
//#define NUM_ZV_DELAY 15     /*    */
//#define NUM_DELAY 11        /*      */
//#define NUM_IMPULS 10       /*     */

/*extern int takt,
    rejim,
    print_per[MAX_NUM_PER],
    num_pere,
    print_num,
    schet;
extern double h,h_5,          /*        */
//       h_out,           /*        */
//       T_beg,             /*    */
//       T_end,            /*     */
/*       y[2][50],
       d[4][50],
       x[100],
       xmax[MAX_NUM_PER],
       xmin[MAX_NUM_PER],
       T,
       max_point;
extern struct zapazdivanie               /*    */
//   {
//   double x[NUM_DELAY];
//   int celoe_old;
//   } zv_delay[NUM_ZV_DELAY];
//extern double x_impuls[NUM_IMPULS];
//extern int num_impuls;            /*     */

/*----------------   ---------------------------*/
/*-----------------   -----------------------------------*/
/*double sign(double input)
{
if (input>0)
   return(1);
else if (input<0)
        return(-1);
     else
        return(0);
}
/*-----------------  ------------------------------------------*/
/*void maximum(double var,double *var_max)
{
if (var>*var_max)
   *var_max=var;
}
/*-----------------  -------------------------------------------*/
/*void minimum(double var,double *var_min)
{
if (var<*var_min)
   *var_min=var;
}

/*---------------   ------------------------------*/
/*----------------   ---------------------------*/
double deriv_integ(double T, double ur_in)
{
	return (ur_in/T);
}
/*----------------    -----------------*/
double deriv_aper(double K, double T, double ur_in, double ur_out)
{
	return ((K*ur_in-ur_out)/T);
}
/*----------------     -----*/
/*double deriv_rderiv(double t2,double vx,int num_din,...)
{
	return ((vx-y[1][num_din])/t2);
}
/*----------------    -------------------*/
/*double rderiv(double t1,double t2,double vx,int num_din,...)
{
	return ((vx-y[1][num_din])*t1/t2);
}
/*----------------     ----------*/
/*double deriv_rfors(double k,double t1,double t2,double vx,int num_din)
{
	return (deriv_aper(1,t2,k*(1-t1/t2)*vx,num_din));
}
/*----------------    ------------------------*/
/*double rfors(double k,double t1,double t2,double vx,int num_din)
{
	return (k*t1/t2*vx+y[1][num_din]);
}
/*----------------    ------------------*/
/*double deriv_koleb(double k,double e,double t,double vx,int num_din)
{
	d[takt][num_din+1]=deriv_integ(2*e*t/k,vx-y[1][num_din]/k);
	return (deriv_aper(1,t/2/e,y[1][num_din+1],num_din));
}
/*---------------- - --------------------------------------*/
/*double pireg(double t1,double t2,double vx,int num_din,...)
{
	return (vx*t1/t2+y[1][num_din]);
}
/*----------------    ---------------------*/
/*double deriv_srkvad(double t,double vx,...)
{
	if (T<t)
	  return (0);
	else
	  return (vx*vx);
}
/*----------------   -----------------------------------*/
/*double srkvad(double t,int num_din,...)
{
	if (T<t)
	   return(0);
	else
	   return (sqrt(1/(T+h-t)*y[1][num_din]));
}
/*----------------     -------------------*/
/*double integ_u(double nu,double vx_obn,int num_din,...)
{
	if (vx_obn<=0)
	   return(y[1][num_din]);
	else
	   {
	   y[0][num_din]=nu;
	   y[1][num_din]=nu;
	   return (nu);
	   }
}
/*----------------   --------------------------------*/
/*double f_delay(double Tk,double input,int num_delay,...)
{
	int celoe,i;

	celoe= (int)floor(NUM_DELAY*T/Tk);
	if (celoe!=zv_delay[num_delay].celoe_old)
	   {
	   for (i=NUM_DELAY-1;i>0;i--)
	      zv_delay[num_delay].x[i]=zv_delay[num_delay].x[i-1];
	   zv_delay[num_delay].x[0]=input;
	   zv_delay[num_delay].celoe_old=celoe;
	   }
	return(zv_delay[num_delay].x[NUM_DELAY-1]);
}
/*----------------  ---------------------------------------*/
/*-----------------  -----------------------------------------*/
double gen_step(double Um, double Tvk, double t)
{
	if (t>Tvk) return(Um);
	else return(0);
}
/*------------------   -----------------------------*/
double gen_line(double K, double Tvk, double t)
{
	if (t>=Tvk) return(K*(t-Tvk));
	else return(0);
}
/*------------------   ------------------------------*/
double gen_imp(double Um, double T, double h, double t)
{
	if (fmod(t,T)<h) return(Um);
	else return(0);
}
/*------------------  -------------------------------------------*/
double gen_meandr(double Um, double T, double t)
{
	if (fmod(t,T)<T/2) return(Um);
	else return(-Um);
}
/*------------------  -------------------------------------------*/
double gen_pila(double Um, double T, double t)
{
	double t1,t4,Up;
	t1=fmod(t,T);
	t4=T/4;
	Up=Um/t4*t1;
	if (t1<t4) return(Up);
	else if (t1<3*t4) return(2*Um-Up);
	else return(-4*Um+Up);
}
/*-------------------   -----------------------*/
double gen_sinT(double Um, double T, double t)
{
	return(Um*sin(PI2*t/T));
}
/*-------------------   -----------------------*/
double gen_cosT(double Um,double T, double t)
{
	return(Um*cos(PI2*t/T));
}
/*-------------------   -----------------------*/
double gen_sin(double Um, double w, double f, double t)
{
	return(Um*sin(w*t+f));
}

/*----------------  -------------------------------------*/
/*-----------------  -----------------------------------------*/
/*double limit(double k, double Umax, double vx)
{
if ( (k*fabs(vx)) < Umax )
   return(k*vx);
else
   return(Umax*sign(vx));
/*-----------------   ---------------------------*/
/*}
double zona( double a, double k,double input)
{
double input_abs;

input_abs=fabs(input);
if (input_abs < a)
   return(0);
else
   return((input_abs-a)*k*sign(input));
}
/*----------------- -  --------------------*/
/*double kusok(double x1,double x2,double k1,double k2,double k3,double input)
{
double input_abs,input_sign;

input_abs=fabs(input);
input_sign=sign(input);
if (input_abs<x1)
   return(input*k1);
else if (input_abs<x2)
        return((x1*k1+(input_abs-x1)*k2)*input_sign);
     else
        return((x1*k1+(x2-x1)*k2+(input_abs-x2)*k3)*input_sign);
}
/*----------------- -  --------------------*/
/*double kusok6(double x1,double x2,double x3,double x4,double x5,double k1,double k2,double k3,double k4,double k5,double k6,double input)
{
double input_abs,input_sign;

input_abs=fabs(input);
input_sign=sign(input);
if (input_abs<x1)
   return(input*k1);
else if (input_abs<x2)
   return((x1*k1+(input_abs-x1)*k2)*input_sign);
else if (input_abs<x3)
   return((x1*k1+(x2-x1)*k2+(input_abs-x2)*k3)*input_sign);
else if (input_abs<x4)
   return((x1*k1+(x2-x1)*k2+(x3-x2)*k3+(input_abs-x3)*k4)*input_sign);
else if (input_abs<x5)
   return((x1*k1+(x2-x1)*k2+(x3-x2)*k3+(x4-x3)*k4+(input_abs-x4)*k5)*input_sign);
else
   return((x1*k1+(x2-x1)*k2+(x3-x2)*k3+(x4-x3)*k4+(x5-x4)*k5+(input_abs-x5)*k6)*input_sign);
}
/*-----------------  ----------------------------------------------*/
/*double rele(double Umax,double vx)
{
if (vx>=0)
   return(Umax);
else
   return(-Umax);
}
/*-----------------  --------------------------------------------*/
/*double trenie(double M0,double M1,double zona_sk,double Mvx,double Wvx)
{
if (fabs(Wvx) > zona_sk)
   return(Mvx-M1*sign(Wvx));
else if (fabs(Mvx) > M0)
   return( Mvx-M1*sign(Mvx) );
else
   return(0);
}
/*-----------------  ------------------------------------------*/
/*double f_max(double var,double var_max)
{
if (var>var_max)
   var_max=var;
return(var_max);
}
/*-----------------  -------------------------------------------*/
/*double f_min(double var,double var_min)
{
if (var<var_min)
   var_min=var;
return(var_min);
}
/*-----------------   -----------------------------------*/
/*double maxmod(double var,double var_max)
{
double var_abs;

var_abs=fabs(var);
if (var_abs>var_max)
   var_max=var_abs;
return(var_max);
}
/*-----------------  ----------------------------------------------*/
/*double rele_p(double Umax,double x1,double x2,double vx,double old)
{
if (old==0)
   return(Umax);
else
   {
   if (vx<=x1)
      return(-Umax);
   else if (vx>=x2)
      return(Umax);
   else
      return(old);
   }
}
/*----------------   --------------------------------*/
/*-----------------    ---------------------------*/
/*double kvant_v(double Tk,double input,double old)
{
if (fmod(T,Tk)<h_5)
   return(input);
else
   return(old);
}
/*-----------------   -------------------------*/
/*double dderiv(double Tk,double input,double old)
{
if (fmod(T,Tk)<h_5)
   return(input);
else
   return(old);
}
/*----------------   --------------------------------*/
/*-----------------  ----------------------------------------*/
/*double compar(double absc,double input)
{
if (fabs(input)<absc)
   return(0);
else
   return(1);
}
/*-----------------  ---------------------------------------------*/
/*double key(double input1,double input2,double uprav)
{
if (uprav<=0)
   return(input1);
else
   return(input2);
}
/*-----------------  ''------------------------------------*/
/*double and(double input1,double input2)
{
if (input1>0 && input2>0)
   return(1);
else
   return(0);
}
/*-----------------  '' ---------------------------------*/
/*double or(double input1,double input2)
{
if (input1>0 || input2>0)
   return(1);
else
   return(0);
}
/*-----------------  ''-----------------------------------*/
/*double not(double input)
{
if (input>0 )
   return(0);
else
   return(1);
}
/*----------------- RS-  --------------------------------------*/
/*double rs_trigger(double s_input,double r_input,double memory)
{
if (r_input>0 )
   return(0);
else if (s_input>0 || memory>0)
   return(1);
else
   return(0);
}
/*-----------------   --------------------------*/
/*double fi(double deltT,double input,double memory)
{
double output;
if (input<=0 )
   output=x_impuls[num_impuls]=0;
else if (memory<=0 && x_impuls[num_impuls]==0)
   {
   x_impuls[num_impuls]=T;
   output=1;
   }
else if (memory>0 && T<=(x_impuls[num_impuls]+deltT))
   output=1;
else
   output=0;
num_impuls++;
return(output);
}
/*----------------   ----------------------------*/
/*----------------- SIN -----------------------------------------------*/
/*double f_sin(double a,double w,double input)
{
return( a * sin ( w * input ) );
}
/*----------------- COS -----------------------------------------------*/
/*double f_cos(double a,double w,double input)
{
return( a * cos ( w * input ) );
}
/*----------------- ABS -----------------------------------------------*/
/*double f_abs(double input)
{
return( fabs ( input ) );
}
/*-----------------   -------------------------------*/
/*double f_usil(double k,double input)
{
int x,y;
if (k!=0)
   return( input / k );
else
   {
//   x=wherex();
//   y=wherey();
//   gotoxy(1,25);
//   cprintf("  /0 ");
//   gotoxy(x,y);
   return(0);
   }
}
/*-----------------   -----------------------------*/
/*double f_pokaz(double a,double input)
{
return( pow (a,input) );
}
/*-----------------   ---------------------------------*/
/*double f_stepen(double a,double input)
{
return( pow (input,a) );
}
/*-----------------  -------------------------------------------*/
/*double f_tg(double input)
{
return( tan (input) );
}
/*-----------------  ----------------------------------------*/
/*double f_arctg(double input)
{
return( atan (input) );
}
/*-----------------  ------------------------------------------*/
/*double f_delit(double input1, double input2 )
{
int x,y;

if (input2!=0)
   return( input1/input2 );
else
   {
   if(input1!=0)
      {
//      x=wherex();
//      y=wherey();
//      gotoxy(1,25);
//      cprintf("H. 0/0 ");
//      gotoxy(x,y);
      }
   return( 1e30*sign(input1));
   }
}
/*-----------------   'P'  'Q' ----------------------------*/
/*double f_ampl(double p,double q)
{
return( sqrt(p*p+q*q) );
}
/*-----------------   'P'  'Q' ---------------------------------*/
/*double f_faza(double tip,double p,double q)
{
if (tip<0.5)
   return( atan( f_delit(p,q)));
else
   return( 360./PI2*atan( f_delit(p,q)));
}
/*----------------- The end -------------------------------------------*/

