//---------------------------------------------------------------------------
#ifndef strucfrmH
#define strucfrmH
//---------------------------------------------------------------------------
#include "block.h"
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ActnList.hpp>
#include <Menus.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <ToolWin.hpp>
#include <Dialogs.hpp>
//---------------------------------------------------------------------------

class TBlkMassiv
{
public:
	double* Y;
    double* Y0;
    double* Y1;
    double* D;
    double* X;
    blks* g_type;
    blks* ur_type;
    int* ur_in;
    double* arg1;
    double* arg2;
    double* arg3;
};
//---------------------------------------------------------------------------

class TStructFrm : public TForm
{
__published:	// IDE-managed Components
	TActionList *ActionList1;
	TAction *AGenStep;
	TAction *AGenLine;
	TAction *AGenMeandr;
	TAction *AGenSinT;
	TAction *AGenCosT;
	TAction *AAperiod;
	TAction *AGenImp;
	TAction *AIntegr;
	TAction *APIReg;
	TAction *AProporc;
	TAction *ASumBlk;
	TAction *AMulBlk;
	TAction *ACAP;
	TAction *AACP;
	TAction *AGraph;
	TMainMenu *MainMenu1;
	TMenuItem *N1;
	TMenuItem *N2;
	TMenuItem *N3;
	TMenuItem *N4;
	TMenuItem *N5;
	TMenuItem *N6;
	TMenuItem *Sinwt1;
	TMenuItem *Coswt1;
	TMenuItem *N7;
	TMenuItem *N8;
	TMenuItem *N9;
	TMenuItem *N10;
	TMenuItem *N11;
	TAction *ARotate;
	TAction *ADelete;
	TMenuItem *N12;
	TMenuItem *N13;
	TMenuItem *N14;
	TImageList *GeneratList;
	TPageControl *PageControl1;
	TTabSheet *TabSheet1;
	TToolBar *ToolBar1;
	TToolButton *ToolButton1;
	TToolButton *ToolButton2;
	TToolButton *ToolButton3;
	TToolButton *ToolButton4;
	TToolButton *ToolButton5;
	TTabSheet *TabSheet2;
	TTabSheet *TabSheet3;
	TImageList *AlgebraList;
	TToolBar *ToolBar2;
	TToolButton *ToolButton6;
	TToolButton *ToolButton7;
	TToolButton *ToolButton8;
	TTabSheet *TabSheet4;
	TImageList *GraphList;
	TToolBar *ToolBar3;
	TToolButton *ToolButton9;
	TImageList *DinamList;
	TToolBar *ToolBar4;
	TToolButton *ToolButton10;
	TToolButton *ToolButton11;
	TToolButton *ToolButton12;
	TAction *ASave;
	TAction *ASaveAs;
	TMenuItem *N15;
	TMenuItem *N16;
	TMenuItem *N17;
	TMenuItem *N18;
	TMenuItem *N19;
	TMenuItem *N20;
	TMenuItem *N21;
	TMenuItem *N22;
	TMenuItem *N23;
	TMenuItem *N24;
	TMenuItem *N25;
	TMenuItem *N26;
	TMenuItem *N27;
	TMenuItem *N28;
	TMenuItem *N29;
	TMenuItem *N30;
	TSaveDialog *SaveDialog1;
	TAction *ACalc;
	TMenuItem *ACalc1;
	TMenuItem *N31;
	TMenuItem *N32;
	TMenuItem *N33;
	TMenuItem *N34;
	TMenuItem *N35;
	TMenuItem *N36;
	TImageList *PlateList;
	TTabSheet *TabSheet5;
	TToolBar *ToolBar5;
	TToolButton *ToolButton13;
	TToolButton *ToolButton14;
	TToolButton *ToolButton15;
	TTabSheet *TabSheet6;
	TToolBar *ToolBar6;
	TToolButton *ToolButton16;
	TToolButton *ToolButton17;
	TImageList *StaticList;
	TAction *AZi;
	TAction *AOgr;
	TAction *APrintGraph;
	TAction *APrintStruct;
	TMenuItem *N37;
	TToolButton *ToolButton18;
	TToolButton *ToolButton19;
	TAction *AUnselect;
	TMenuItem *N38;
	TMenuItem *N39;
	TToolButton *ToolButton20;
	TToolButton *ToolButton21;
	TToolButton *ToolButton22;
	TToolButton *ToolButton23;
	TToolButton *ToolButton24;
	TToolButton *ToolButton25;
	TToolButton *ToolButton26;
	TToolButton *ToolButton27;
	TToolButton *ToolButton28;
	TToolButton *ToolButton29;
	TScrollBox *SB;
	TPaintBox *PB;
	void __fastcall FormMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall FormMouseMove(TObject *Sender, TShiftState Shift, int X,
          int Y);
	void __fastcall FormMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall FormPaint(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall AGenStepExecute(TObject *Sender);
	void __fastcall AGenLineExecute(TObject *Sender);
	void __fastcall AGenMeandrExecute(TObject *Sender);
	void __fastcall AGenSinTExecute(TObject *Sender);
	void __fastcall AGenCosTExecute(TObject *Sender);
	void __fastcall AAperiodExecute(TObject *Sender);
	void __fastcall AGenImpExecute(TObject *Sender);
	void __fastcall AIntegrExecute(TObject *Sender);
	void __fastcall APIRegExecute(TObject *Sender);
	void __fastcall AProporcExecute(TObject *Sender);
	void __fastcall ASumBlkExecute(TObject *Sender);
	void __fastcall AMulBlkExecute(TObject *Sender);
	void __fastcall ACAPExecute(TObject *Sender);
	void __fastcall AACPExecute(TObject *Sender);
	void __fastcall AGraphExecute(TObject *Sender);
	void __fastcall ABlockUpdate(TObject *Sender);
	void __fastcall ARotateExecute(TObject *Sender);
	void __fastcall ADeleteExecute(TObject *Sender);
	void __fastcall ASaveExecute(TObject *Sender);
	void __fastcall ASaveAsExecute(TObject *Sender);
	void __fastcall ACalcExecute(TObject *Sender);
	void __fastcall AZiExecute(TObject *Sender);
	void __fastcall AOgrExecute(TObject *Sender);
	void __fastcall APrintGraphUpdate(TObject *Sender);
	void __fastcall APrintGraphExecute(TObject *Sender);
	void __fastcall AUnselectExecute(TObject *Sender);
private:	// User declarations
public:		// User declarations
	__fastcall TStructFrm(TComponent* Owner);
    __fastcall ~TStructFrm();
    TConnectLine* TracingLine;
    TPoint startPt;
    TPoint endPt;
    bool sel_fl;
    blks cur_block;
    double h;
	double rasch_time;
    double t;
	TBlock* __fastcall m_get_block(blks t_block);
	void __fastcall m_set_block(int X, int Y);
	void __fastcall RK(int N_difur, int N_gener, int N_proporc, int N_sumblk, int N_mulblk, int N_zi, int N_ogr, TBlkMassiv* m_m);
	double __fastcall generators(blks g_type, double arg1, double arg2, double arg3);
	double  __fastcall equations(blks ur_type, double ur_in, double ur_out, double arg1, double arg2, double arg3);
	void __fastcall calculate();
	void __fastcall SaveToFile(AnsiString m_file);
	void __fastcall LoadFromFile(AnsiString m_file);
	AnsiString m_FileName;
};
//---------------------------------------------------------------------------
extern PACKAGE TStructFrm *StructFrm;
//---------------------------------------------------------------------------
#endif
