//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "tablfrm.h"
#include "graphunt.h"
#include <clipbrd.hpp>
#include <stdio.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TGridFrm *GridFrm;
//---------------------------------------------------------------------------
__fastcall TGridFrm::TGridFrm(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TGridFrm::GridDrawCell(TObject *Sender, int ACol, int ARow,
      TRect &Rect, TGridDrawState State)
{
	int y = (Rect.top + Rect.bottom)/2 + Grid->Canvas->Font->Height/2;
	int x = (Rect.left + Rect.right)/2;
	SetTextAlign(Grid->Canvas->Handle,TA_CENTER);
	if(ARow == 0)
	{
		if(ACol == 0)
		{
			if(!m_static) Grid->Canvas->TextRect(Rect,x,y,"t, c");
			else Grid->Canvas->TextRect(Rect,x,y,"");
		}
		else
		{
			if(m_razmern[ACol-1] == "") Grid->Canvas->TextRect(Rect,x,y,m_labels[ACol-1]);
			else Grid->Canvas->TextRect(Rect,x,y,m_labels[ACol-1]+", "+m_razmern[ACol-1]);
		}
    }
	else if(ACol > 0)
	{
		int index, i, j, req_i, req_j;
		short tmp[32];
		FILE* data_file = fopen(m_file.c_str(),"rb");
		fseek(data_file,sizeof(short)*(ARow-1)*col_can,SEEK_SET);
		fread(tmp,sizeof(short),col_can,data_file);
		for(j=0, index=0; j<2; j++)
        	for(i=0; (i<16)&&(index<ACol); i++)
            {
            	req_i = i;
                req_j = j;
            	if((m_coords_to_show[j]>>i)&1)
                {
					index++;
                }
            }
        for(j=0, index=0; j<req_j; j++)
        	for(i=0; i<16; i++)
            	index += (m_coords_mask[j]>>i)&1;
        for(i=0; i<req_i; i++)
        	index += (m_coords_mask[j]>>i)&1;
		Grid->Canvas->TextRect(Rect,x,y,FloatToStrF((double)tmp[index]/511*m_base[ACol-1],ffFixed,10,3));
		fclose(data_file);
	}
	else
	{
		if(!m_static) Grid->Canvas->TextRect(Rect,x,y,FloatToStrF((ARow-1)*m_tstep,ffFixed,10,3));
		else Grid->Canvas->TextRect(Rect,x,y,IntToStr(ARow));
	}
}
//---------------------------------------------------------------------------

void __fastcall TGridFrm::FormClose(TObject *Sender, TCloseAction &Action)
{
	((TGraphFrm*)Owner)->m_graph.m_gridFrm = NULL;
	Action = caFree;
}
//---------------------------------------------------------------------------

void __fastcall TGridFrm::mnPrintClick(TObject *Sender)
{
	Print();
}
//---------------------------------------------------------------------------

void __fastcall TGridFrm::mnSaveToBufClick(TObject *Sender)
{
	Graphics::TBitmap *FormImage = GetFormImage();
	Clipboard()->Assign(FormImage);
    delete FormImage;
}
//---------------------------------------------------------------------------

