//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "AStDlg.h"
#include "Main.h"
#include "misc.h"
#include <registry.hpp>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TAutoStatDlg *AutoStatDlg;
//---------------------------------------------------------------------------
__fastcall TAutoStatDlg::TAutoStatDlg(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void TAutoStatDlg::SetCaptions()
{
    int i;
    TabControl->Tabs->Clear();
    for(i=0; i<2; i++) TabControl->Tabs->Add(((TMainForm*)MainForm)->m_labels[1][i]);
}
//---------------------------------------------------------------------------
void TAutoStatDlg::UpdateFields()
{
	TrackBar1->Min = -((TMainForm*)MainForm)->m_offset[1][TabControl->TabIndex];
	TrackBar1->Max = 1022 + TrackBar1->Min;
    TrackBar2->Max = TrackBar1->Max;
    TrackBar2->Min = TrackBar1->Min;
    TrackBar1->Position = (int)(m_nach_zn[TabControl->TabIndex]/((TMainForm*)MainForm)->m_base[1][TabControl->TabIndex]*511);
    TrackBar2->Position = (int)(m_kon_zn[TabControl->TabIndex]/((TMainForm*)MainForm)->m_base[1][TabControl->TabIndex]*511);
    ENach->Text = FloatToStrF(m_nach_zn[TabControl->TabIndex],ffFixed,10,1);
    EKon->Text = FloatToStrF(m_kon_zn[TabControl->TabIndex],ffFixed,10,1);
//    EKol->Text = IntToStr(m_kol[TabControl->TabIndex]);
    UpDown1->Position = (short)m_kol[TabControl->TabIndex];
    EShagVr->Text = FloatToStrF(m_shag_vrem[TabControl->TabIndex],ffFixed,10,3);
    ERazm1->Text = ((TMainForm*)MainForm)->m_razmern[1][TabControl->TabIndex];
    ERazm2->Text = ERazm1->Text;
}
//---------------------------------------------------------------------------
void TAutoStatDlg::SaveFields()
{
    m_nach_zn[TabControl->TabIndex] = myStrToFloat(ENach->Text);
    m_kon_zn[TabControl->TabIndex] = myStrToFloat(EKon->Text);
//    m_kol[TabControl->TabIndex] = StrToInt(EKol->Text);
    m_kol[TabControl->TabIndex] = UpDown1->Position;
    m_shag_vrem[TabControl->TabIndex] = myStrToFloat(EShagVr->Text);
}
//---------------------------------------------------------------------------
void __fastcall TAutoStatDlg::TabControlChanging(TObject *Sender,
      bool &AllowChange)
{
    SaveFields();
}
//---------------------------------------------------------------------------
void __fastcall TAutoStatDlg::TabControlChange(TObject *Sender)
{
    UpdateFields();
}
//---------------------------------------------------------------------------
void __fastcall TAutoStatDlg::TrackBar1Change(TObject *Sender)
{
    m_nach_zn[TabControl->TabIndex] = (double)TrackBar1->Position/511*((TMainForm*)MainForm)->m_base[1][TabControl->TabIndex];
    ENach->Text = FloatToStrF(m_nach_zn[TabControl->TabIndex],ffFixed,10,1);
}
//---------------------------------------------------------------------------
void __fastcall TAutoStatDlg::TrackBar2Change(TObject *Sender)
{
    m_kon_zn[TabControl->TabIndex] = (double)TrackBar2->Position/511*((TMainForm*)MainForm)->m_base[1][TabControl->TabIndex];
    EKon->Text = FloatToStrF(m_kon_zn[TabControl->TabIndex],ffFixed,10,1);
}
//---------------------------------------------------------------------------
void TAutoStatDlg::ReadIniFile()
{
	TIniFile* RegFile = new TIniFile(((TMainForm*)MainForm)->m_ini_name);
	TabControl->TabIndex = RegFile->ReadFloat("  (defaults)"," ",0);
    for(int i=0; i<2; i++)
    {
    	m_nach_zn[i]   = RegFile->ReadFloat("  (defaults)",".  "+IntToStr(i),0);
	    m_kon_zn[i]	   = RegFile->ReadFloat("  (defaults)",".  "+IntToStr(i),0);
    	m_kol[i]       = RegFile->ReadFloat("  (defaults)","- ."+IntToStr(i),10);
	    m_shag_vrem[i] = RegFile->ReadFloat("  (defaults)","  "+IntToStr(i),0);
    }
    delete RegFile;
}
//---------------------------------------------------------------------------
void TAutoStatDlg::SaveIniFile()
{
	TIniFile* RegFile = new TIniFile(((TMainForm*)MainForm)->m_ini_name);
	RegFile->WriteFloat("  (defaults)"," ",TabControl->TabIndex);
    for(int i=0; i<2; i++)
    {
    	RegFile->WriteFloat("  (defaults)",".  "+IntToStr(i),m_nach_zn[i]);
	    RegFile->WriteFloat("  (defaults)",".  "+IntToStr(i),m_kon_zn[i]);
    	RegFile->WriteFloat("  (defaults)","- ."+IntToStr(i),m_kol[i]);
	    RegFile->WriteFloat("  (defaults)","  "+IntToStr(i),m_shag_vrem[i]);
    }
    delete RegFile;
}
//---------------------------------------------------------------------------


