//----------------------------------------------------------------------------
#ifndef MainH
#define MainH
//----------------------------------------------------------------------------
#include "graphunt.h"
#include <vcl\ComCtrls.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Messages.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\Dialogs.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Menus.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Graphics.hpp>
#include <vcl\Classes.hpp>
#include <vcl\SysUtils.hpp>
#include <vcl\Windows.hpp>
#include <vcl\System.hpp>
#include <ActnList.hpp>
#include <ImgList.hpp>
#include <StdActns.hpp>
#include <ToolWin.hpp>
#include ".\PgSetup\PgSetup.hpp"
//----------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:
	TMainMenu *MainMenu1;
	TMenuItem *Window1;
	TMenuItem *Help1;
	TMenuItem *WindowCascadeItem;
	TMenuItem *WindowTileItem;
	TMenuItem *WindowArrangeItem;
	TMenuItem *HelpAboutItem;
	TOpenDialog *OpenDialog;
	TMenuItem *WindowMinimizeItem;
    TActionList *ActionList1;
	TAction *APerehHar;
	TAction *FileExit;
	TAction *FileOpen;
	TWindowCascade *WindowCascade;
	TWindowTileHorizontal *WindowTileHorizontal;
	TWindowArrange *WindowArrangeAll;
	TWindowMinimizeAll *WindowMinimizeAll;
	TAction *HelpAbout;
	TWindowClose *FileClose;
	TWindowTileVertical *WindowTileVertical;
    TMenuItem *WindowTileItem2;
    TImageList *ImageList1;
	TAction *AStructFrm;
	TAction *AStaticHar;
	TMenuItem *File;
	TMenuItem *N1;
	TMenuItem *N2;
	TMenuItem *N3;
	TMenuItem *N4;
	TMenuItem *N5;
	TMenuItem *N6;
	TMenuItem *N7;
	TMenuItem *N8;
	TAction *ANastrACP;
	TAction *ANastrCAP;
	TAction *AParams;
	TMenuItem *N9;
	TMenuItem *N10;
	TMenuItem *N11;
	TMenuItem *N12;
	TMenuItem *N13;
	TAction *ACalibrZero;
	TMenuItem *N14;
	TMenuItem *N15;
	TPrinterSetupDialog *PrinterSetupDialog;
	TAction *APrintSetup;
	TMenuItem *N16;
	TMenuItem *N17;
	TAction *AResetZero;
	TMenuItem *N18;
	TdfsPageSetupDialog *PageSetupDialog;
	TAction *APageSetup;
	TMenuItem *N19;
	TControlBar *ControlBar1;
	TToolBar *ToolBar1;
	TToolButton *ToolButton1;
	TToolButton *ToolButton2;
	TToolButton *ToolButton3;
	TToolButton *ToolButton4;
	TToolButton *ToolButton5;
	TToolButton *ToolButton6;
	TToolButton *ToolButton7;
	TToolButton *ToolButton8;
    void __fastcall APerehHarExecute(TObject *Sender);
	void __fastcall FileOpenExecute(TObject *Sender);
	void __fastcall HelpAboutExecute(TObject *Sender);
	void __fastcall FileExitExecute(TObject *Sender);
	void __fastcall AStructFrmExecute(TObject *Sender);
	void __fastcall AParamsExecute(TObject *Sender);
	void __fastcall ANastrACPExecute(TObject *Sender);
	void __fastcall AStaticHarExecute(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall ANastrCAPExecute(TObject *Sender);
	void __fastcall ACalibrZeroExecute(TObject *Sender);
	void __fastcall APrintSetupExecute(TObject *Sender);
	void __fastcall AResetZeroExecute(TObject *Sender);
	void __fastcall APageSetupExecute(TObject *Sender);
private:
public:
	AnsiString m_labels[2][16];
    AnsiString m_razmern[2][16];
    AnsiString m_ini_name;
    double m_base[2][16];
    double m_real_base[2][16];
	short m_offset[2][16];
    short m_filter_mask;
	virtual __fastcall TMainForm(TComponent *Owner);
    void __fastcall ResetCAP(short val_CAP[16]);
    void __fastcall ResetCAP();
    void __fastcall ReadIniFile();
    void __fastcall SaveIniFile();
	DWORD ScanPriorClass;
	DWORD ScanThreadPrior;
	DWORD AppPriorClass;
	DWORD AppThreadPrior;
    int m_col_can_CAP;
    double m_Tzi;
};
//----------------------------------------------------------------------------
extern TMainForm *MainForm;
//extern TGraphFrm *__fastcall MDIChildCreate(void);
//----------------------------------------------------------------------------
#endif
