//---------------------------------------------------------------------------
#ifndef rk_funcsH
#define rk_funcsH

double deriv_integ(double T, double ur_in);
double deriv_aper(double K, double T, double ur_in, double ur_out);
/*double rderiv(double t1,double t2,double vx,int num_din,...);
double deriv_rderiv(double t2,double vx,int num_din,...);
double deriv_rfors(double k,double t1,double t2,double vx,int num_din);
double rfors(double k,double t1,double t2,double vx,int num_din);
double deriv_koleb(double k,double e,double t,double vx,int num_din);
double pireg(double t1,double t2,double vx,int num_din,...);
double deriv_srkvad(double t,double vx,...);
double srkvad(double t,int num_din,...);
double integ_u(double nu,double vx_obn,int num_din,...);
double f_delay(double Tk,double input,int num_delay,...);*/

double gen_step(double Um, double Tvk, double t);
double gen_line(double K, double Tvk, double t);
double gen_imp(double Um, double T, double h, double t);
double gen_meandr(double Um, double T, double t);
double gen_pila(double Um, double T, double t);
double gen_sinT(double Um, double T, double t);
double gen_cosT(double Um, double T, double t);
double gen_sin(double Um, double w, double f, double t);

/*double limit(double k, double Umax, double vx);
double zona( double a, double k,double input);
double kusok(double x1,double x2,double k1,double k2,double k3,double input);
double kusok6(double x1,double x2,double x3,double x4,double x5,double k1,double k2,double k3,double k4,double k5,double k6,double input);
double rele(double Umax,double vx);
double trenie(double M0,double M1,double zona_sk,double Mvx,double Wvx);
double f_max(double var,double var_max);
double f_min(double var,double var_min);
double maxmod(double var,double var_max);
double rele_p(double Umax,double x1,double x2,double vx,double old);

double kvant_v(double Tk,double input,double old);

double f_sin(double a,double w,double input);
double f_cos(double a,double w,double input);
double f_abs(double input);
double f_usil(double k,double input);
double f_pokaz(double a,double input);
double f_stepen(double a,double input);
double f_tg(double input);
double f_arctg(double input);
double f_delit(double input1, double input2 );
double f_ampl(double p,double q);
double f_faza(double tip,double p,double q);

//double compar(double absc,double input);                       /*        */
//double key(double input1,double input2,double uprav);          /*              */
//double and(double input1,double input2);                       /*  ''   */
//double or(double input1,double input2);                        /*  '' */
//double not(double input);                                      /*  ''  */
//double rs_trigger(double s_input,double r_input,double memory);/* RS-       */
//double fi(double deltT,double input,double memory);            /* . */

/*double sign(double input);
void maximum(double var,double *var_max);
void minimum(double var,double *var_min);*/

//---------------------------------------------------------------------------
#endif
