//---------------------------------------------------------------------------
#ifndef statdlgH
#define statdlgH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ActnList.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Grids.hpp>
#include <Buttons.hpp>
//---------------------------------------------------------------------------
class TStaticDlg : public TForm
{
__published:	// IDE-managed Components
	TStringGrid *StringGrid1;
	TTrackBar *TrackBar1;
	TTrackBar *TrackBar2;
	TButton *Button3;
	TButton *Button4;
	TButton *Button5;
	TLabel *Label1;
	TLabel *Label2;
	TActionList *ActionList1;
	TAction *ASavePoint;
	TAction *AStNastr;
	TAction *AAutoStart;
	TEdit *Edit1;
	TEdit *Edit2;
	TTimer *TimerBg;
	TPanel *Panel1;
	TLabel *Label4;
	TLabel *Label3;
	TPaintBox *PaintBox1;
	TCheckBox *ChBStartFromStend;
	TBitBtn *BitBtn1;
	TBitBtn *BitBtn2;
    TEdit *ERazm1;
    TEdit *ERazm2;
    TTimer *TimerAuto;
	TButton *Button1;
	TButton *Button2;
	TAction *ADeletePoint;
	TAction *ADeleteAll;
	TBevel *Bevel1;
	void __fastcall ASavePointExecute(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall TrackBar1ChangeComplex(TObject *Sender);
	void __fastcall TrackBar2ChangeComplex(TObject *Sender);
	void __fastcall TrackBar1ChangeSimple(TObject *Sender);
	void __fastcall TrackBar2ChangeSimple(TObject *Sender);
	void __fastcall TimerBgTimer(TObject *Sender);
	void __fastcall PaintBox1Paint(TObject *Sender);
	void __fastcall PaintBox1MouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall AStNastrExecute(TObject *Sender);
	void __fastcall AAutoStartExecute(TObject *Sender);
    void __fastcall TimerAutoTimer(TObject *Sender);
	void __fastcall ADeletePointExecute(TObject *Sender);
	void __fastcall ADeletePointUpdate(TObject *Sender);
	void __fastcall ADeleteAllExecute(TObject *Sender);
	void __fastcall ADeleteAllUpdate(TObject *Sender);
private:	// User declarations
public:		// User declarations
	__fastcall TStaticDlg(TComponent* Owner);
	void __fastcall m_SavePoint();
    void __fastcall m_SetCaptions();
    void __fastcall ReadIniFile();
    void __fastcall SaveIniFile();
	AnsiString m_file;
	int m_col_points;
    double m_auto_beg;
    double m_auto_end;
    double m_auto_step;
    double m_auto_time_step;
    double m_auto_tmp;
    bool m_auto_finish;
    int m_CAP_index;
    short coords_to_show[2];
    short CAP_val[16];
    short CAP_tmp[16];
	long clock_beg;
};
//---------------------------------------------------------------------------
extern PACKAGE TStaticDlg *StaticDlg;
//---------------------------------------------------------------------------
#endif
